/* error_routines.h: General error routines.

This file is part of Omega,
which is based on the web2c distribution of TeX,

Copyright (c) 1994--2001 John Plaice and Yannis Haralambous

Omega is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Omega is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Omega; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

*/
#if defined(__GNUC__) && (__GNUC__ >= 3)
#define lex_error_0(a) lex_error("%s", a)
#define lex_error_1(a, b) lex_error(a, b)
#define lex_error_s(a, b) lex_error(a, b)
#define lex_error_s_1(a, b, c) lex_error(a, b, c)
extern void lex_error(string, ...) __attribute__ ((format (printf, 1, 2)));
#define fatal_error_0(a) fatal_error("%s", a)
#define fatal_error_1(a, b) fatal_error(a, b)
#define fatal_error_2(a, b, c) fatal_error(a, b, c)
#define fatal_error_s(a, b) fatal_error(a, b)
extern void fatal_error(string, ...) __attribute__ ((format (printf, 1, 2)));
extern void yyerror(string);
#define warning_0(a) warning_("%s", a)
#define warning_1(a, b) warning_(a, b)
#define warning_2(a, b, c) warning_(a, b, c)
#define warning_s(a, b) warning_(a, b)
#define warning_s_1(a, b, c) warning_(a, b, c)
#define warning_s_2(a, b, c, d) warning_(a, b, c, d)
extern void warning_(string, ...) __attribute__ ((format (printf, 1, 2)));
#define internal_error_0(a) internal_error("%s", a)
#define internal_error_1(a, b) internal_error(a, b)
#define internal_error_s(a, b) internal_error(a, b)
extern void internal_error(string, ...) __attribute__ ((format (printf, 1, 2)));
#else
extern void lex_error_0(string);
extern void lex_error_1(string, int);
extern void lex_error_s(string, string);
extern void lex_error_s_1(string, string, int);

extern void fatal_error_0(string);
extern void fatal_error_1(string, int);
extern void fatal_error_2(string, int, int);
extern void fatal_error_s(string, string);

extern void yyerror(string);

extern void warning_0(string);
extern void warning_1(string, int);
extern void warning_2(string, int, int);
extern void warning_s(string, string);
extern void warning_s_1(string, string, int);
extern void warning_s_2(string, string, int, int);

extern void internal_error_0(string);
extern void internal_error_1(string, int);
extern void internal_error_s(string, string);
#endif

